﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.Linq;
using Telerik.Windows.Controls.ScheduleView;

namespace DatePickerExclusions
{
    public class MyViewModel
    {
        readonly List<TimeSpan> allHours = new List<TimeSpan>
        {
            new TimeSpan(0,0,0),
            new TimeSpan(1,0,0),
            new TimeSpan(2,0,0),
            new TimeSpan(3,0,0),
            new TimeSpan(4,0,0),
            new TimeSpan(5,0,0),
            new TimeSpan(6,0,0),
            new TimeSpan(7,0,0),
            new TimeSpan(8,0,0),
            new TimeSpan(9,0,0),
            new TimeSpan(10,0,0),
            new TimeSpan(11,0,0),
            new TimeSpan(12,0,0),
            new TimeSpan(13,0,0),
            new TimeSpan(14,0,0),
            new TimeSpan(15,0,0),
            new TimeSpan(16,0,0),
            new TimeSpan(17,0,0),
            new TimeSpan(18,0,0),
            new TimeSpan(19,0,0),
            new TimeSpan(20,0,0),
            new TimeSpan(21,0,0),
            new TimeSpan(22,0,0),
            new TimeSpan(23,0,0),
            new TimeSpan(24,0,0)
        };

        public MyViewModel()
        {
            Appointments = CreateAppointments();
            Appointments.CollectionChanged += Appointments_CollectionChanged;
        }

        private void Appointments_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            if (e.Action == NotifyCollectionChangedAction.Add || e.Action == NotifyCollectionChangedAction.Remove)
            {
                UpdateClockItems();
            }
        }

        public ObservableCollection<Appointment> Appointments { get; set; }

        public ObservableCollection<TimeSpan> CustomClockItems { get; set; }

        private static ObservableCollection<Appointment> CreateAppointments()
        {
            return new ObservableCollection<Appointment>
            {
                new Appointment {Subject = "Front-End Meeting", Start = DateTime.Today.AddHours(0), End = DateTime.Today.AddHours(1)},
                new Appointment {Subject = "Planning Meeting", Start = DateTime.Today.AddHours(2), End = DateTime.Today.AddHours(3)}
            };
        }

        private void UpdateClockItems()
        {
            CustomClockItems = new ObservableCollection<TimeSpan>(allHours);

            foreach (var appointment in Appointments)
            {
                CustomClockItems.Remove(CustomClockItems.FirstOrDefault(t => t == appointment.Start.TimeOfDay));
            }
        }
    }
}